{-# LANGUAGE DeriveGeneric #-}

module Types.WebSocketMessages.WebSocketMessages
  ( WebSocketMessage (..),
    SetClientInfo (..),
    JoinRoom (..),
  )
where

import ClassyPrelude
import Data.Aeson
  ( FromJSON (parseJSON),
    Options (sumEncoding),
    SumEncoding (..),
    decode,
    defaultOptions,
    genericParseJSON,
    withObject,
    (.:),
  )

data WebSocketMessage = ClientInfoMessage SetClientInfo | JoinRoomMessage JoinRoom
  deriving (Generic)

instance FromJSON WebSocketMessage where
  parseJSON = genericParseJSON defaultOptions {sumEncoding = UntaggedValue}

data SetClientInfo = SetClientInfo
  { displayName :: Text
  }
  deriving (Generic, Show)

instance FromJSON SetClientInfo

data JoinRoom = JoinRoom
  { roomName :: Text
  }
  deriving (Generic, Show)

instance FromJSON JoinRoom
