import { useEffect } from "react";
import { UserInfo } from "../components/jitsi/types";
import useRoomData from "./useRoomData";
import useWebSocketConnection from "./useWebSocketConnection";

function useBackendData(userInfo: UserInfo) {
  console.log("[Rooms] useBackendData");
  const { onMessage, sendMessage } = useWebSocketConnection(userInfo);

  const { roomData, setRoomData } = useRoomData();

  useEffect(
    () =>
      onMessage((messageString) => {
        console.log("[Rooms] message from ws", messageString);
        const messageObject = JSON.parse(messageString);

        !!messageObject.roomsData && setRoomData(messageObject);
      }),
    [onMessage, setRoomData]
  );

  return { roomData, sendMessage };
}

export default useBackendData;
