import { useState } from "react";
import { ConferenceData } from "../background/jitsi/eventListeners";
import { UserInfo } from "../components/jitsi/types";

function useConferenceData(
  sendMessage: (message: string) => void,
  setUserInfo: (newData: UserInfo) => void
) {
  const [conferenceData, setConferenceDataLocal] = useState<ConferenceData>();

  const setConferenceData = (newData: ConferenceData) => {
    console.log("[Rooms] set conferenceData", conferenceData);
    sendMessage(JSON.stringify(newData));
    setConferenceDataLocal(newData);
    setUserInfo({ displayName: newData.displayName, email: "" });
  };

  return { conferenceData, setConferenceData };
}

export default useConferenceData;
